create or replace package UDO_PKG_EQUIPDS_BASE as

  /*   "  " */
  procedure INS
  (
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    NRN                     out number   --  
  );

  /*   "  " */
  procedure UPD
  (
    NRN                     in number,   --  
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2  -- 
  );

  /*   "  " */
  procedure DEL
  (
    NRN                     in number,  --  
    NCOMPANY                in number   -- 
  );
  
  /*   "   ( )" */
  procedure CM_JOINS
  (
    NCOMPANY                in number,   -- 
    SEQOBJKIND              in varchar2, --  
    SUSERPROCS_DATA         in varchar2, --  
    SEXSSERVICE_UPLOAD      in varchar2, --      FTP
    SEXSSERVICEFN_UPLOAD    in varchar2, --      FTP
    SEXSSERVICE_SEND_MD     in varchar2, --      
    SEXSSERVICEFN_SEND_MD   in varchar2, --      
    SEXSSERVICE_SEND_RQ     in varchar2, --      
    SEXSSERVICEFN_SEND_RQ   in varchar2, --      
    NEQOBJKIND              out number,  -- .   
    NUSERPROCS_DATA         out number,  -- .   
    NEXSSERVICEFN_UPLOAD    out number,  -- .       FTP
    NEXSSERVICEFN_SEND_MD   out number,  -- .       
    NEXSSERVICEFN_SEND_RQ   out number   -- .       
  );
  
  /*   "   ( )" */
  procedure CM_INS
  (
    NPRN                    in number,  -- 
    NEQOBJKIND              in number,  --  
    NUSERPROCS_DATA         in number,  --  
    NEXSSERVICEFN_UPLOAD    in number,  --      FTP
    NEXSSERVICEFN_SEND_MD   in number,  --      
    NEXSSERVICEFN_SEND_RQ   in number,  --      
    NRN                     out number  --  
  );
  
  /*   "   ( )" */  
  procedure CM_UPD
  (
    NRN                     in number,  --  
    NEQOBJKIND              in number,  --  
    NUSERPROCS_DATA         in number,  --  
    NEXSSERVICEFN_UPLOAD    in number,  --      FTP
    NEXSSERVICEFN_SEND_MD   in number,  --      
    NEXSSERVICEFN_SEND_RQ   in number   --      
  );
  
  /*   "   ( )" */
  procedure CM_DEL
  (
    NRN                     in number   --  
  );
  
  /*   "   ( ,  )" */
  procedure CMFL_INS
  (
    NPRN                    in number,   -- 
    SFILE_NAME              in varchar2, --  
    SDESCR                  in varchar2, -- 
    NRN                     out number   --  
  );
  
  /*   "   ( ,  )" */
  procedure CMFL_DEL
  (
    NRN                     in number   --  
  );  

  /*     "   ( ,  )" */  
  procedure CMFL_SET_FILE_NAME
  (
    NRN                     in number,  --  
    SFILE_NAME              in varchar2 --  
  );
  
  /*    "   ( ,  )" */  
  procedure CMFL_SET_STATUS
  (
    NRN                     in number,   --  
    NSTATUS                 in number,   --  (0 - , 1 -   FTP, 2 -    FTP, 3 -    FTP, 4 -    , 5 -     , 6 -       )
    SQUEUE_ID               in varchar2, --   
    SERR                    in varchar2  --   
  );

  /*   "   ( , )" */
  procedure CMML_INS
  (
    NPRN                    in number,   -- 
    STASK                   in varchar2, --  (TCF -    (Technical Condition Forecast), RUL -    (Remaining Useful Life), FP -   (Failure Predict)) */
    NPRECISION_P            in number,   --  ()
    NRN                     out number   --  
  );
  
  /*   "   ( , )" */
  procedure CMML_UPD
  (
    NRN                     in number,   --  
    STASK                   in varchar2, --  (TCF -    (Technical Condition Forecast), RUL -    (Remaining Useful Life), FP -   (Failure Predict)) */
    NPRECISION_P            in number    --  ()
  );
  
  /*   "   ( , )" */
  procedure CMML_DEL
  (
    NRN                     in number   --  
  );  

  /*     "   ( , )" */  
  procedure CMML_SET_PRECISION_F
  (
    NRN                     in number,  --  
    NPRECISION_F            in number   --  ()
  );
  
  /*    "   ( , )" */  
  procedure CMML_SET_STATUS
  (
    NRN                     in number,   --  
    NSTATUS                 in number,   --  (0 - , 1 -   , 2 -    , 3 -      )
    SQUEUE_ID               in varchar2, --   
    SERR                    in varchar2  --   
  );

end UDO_PKG_EQUIPDS_BASE;
/
create or replace package body UDO_PKG_EQUIPDS_BASE as

  /*   "  " */
  procedure INS
  (
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    NRN                     out number   --  
  )
  is
  begin
    /*  .  */
    NRN := GEN_ID();
    /*   */
    insert into UDO_T_EQUIPDS (RN, COMPANY, CODE, name) values (NRN, NCOMPANY, SCODE, SNAME);
  end INS;

  /*   "  " */
  procedure UPD
  (
    NRN                     in number,   --  
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2  -- 
  )
  is
  begin
    /*   */
    update UDO_T_EQUIPDS T
       set T.CODE = SCODE,
           T.NAME = SNAME
     where T.RN = NRN
       and T.COMPANY = NCOMPANY;
  end UPD;

  /*   "  " */
  procedure DEL
  (
    NRN                     in number,  --  
    NCOMPANY                in number   -- 
  )
  is
  begin
    /*   */
    delete from UDO_T_EQUIPDS T
     where T.RN = NRN
       and T.COMPANY = NCOMPANY;
  end DEL;
  
  /*   "   ( )" */
  procedure CM_JOINS
  (
    NCOMPANY                in number,   -- 
    SEQOBJKIND              in varchar2, --  
    SUSERPROCS_DATA         in varchar2, --  
    SEXSSERVICE_UPLOAD      in varchar2, --      FTP
    SEXSSERVICEFN_UPLOAD    in varchar2, --      FTP
    SEXSSERVICE_SEND_MD     in varchar2, --      
    SEXSSERVICEFN_SEND_MD   in varchar2, --      
    SEXSSERVICE_SEND_RQ     in varchar2, --      
    SEXSSERVICEFN_SEND_RQ   in varchar2, --      
    NEQOBJKIND              out number,  -- .   
    NUSERPROCS_DATA         out number,  -- .   
    NEXSSERVICEFN_UPLOAD    out number,  -- .       FTP
    NEXSSERVICEFN_SEND_MD   out number,  -- .       
    NEXSSERVICEFN_SEND_RQ   out number   -- .       
  )
  is
    NEXSSERVICE             PKG_STD.TREF; -- .   
  begin
    /*   */
    FIND_EQOBJKIND_FULLCODE(NFLAG_SMART  => 0,
                            NFLAG_OPTION => 0,
                            NCOMPANY     => NCOMPANY,
                            SCODE        => SEQOBJKIND,
                            NRN          => NEQOBJKIND);
    /*   */
    if (SUSERPROCS_DATA is not null) then
      FIND_USERPROCS_CODE(NFLAG_SMART => 0, SCODE => SUSERPROCS_DATA, NRN => NUSERPROCS_DATA);
    else
      P_EXCEPTION(0, '     .');
    end if;
    /*      FTP */
    FIND_EXSSERVICE_CODE(NFLAG_SMART => 0, NFLAG_OPTION => 0, SCODE => SEXSSERVICE_UPLOAD, NRN => NEXSSERVICE);
    FIND_EXSSERVICEFN_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 0,
                           NEXSSERVICE  => NEXSSERVICE,
                           SCODE        => SEXSSERVICEFN_UPLOAD,
                           NRN          => NEXSSERVICEFN_UPLOAD);
    /*       */
    FIND_EXSSERVICE_CODE(NFLAG_SMART => 0, NFLAG_OPTION => 0, SCODE => SEXSSERVICE_SEND_MD, NRN => NEXSSERVICE);
    FIND_EXSSERVICEFN_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 0,
                           NEXSSERVICE  => NEXSSERVICE,
                           SCODE        => SEXSSERVICEFN_SEND_MD,
                           NRN          => NEXSSERVICEFN_SEND_MD);
    /*       */
    FIND_EXSSERVICE_CODE(NFLAG_SMART => 0, NFLAG_OPTION => 0, SCODE => SEXSSERVICE_SEND_RQ, NRN => NEXSSERVICE);
    FIND_EXSSERVICEFN_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 0,
                           NEXSSERVICE  => NEXSSERVICE,
                           SCODE        => SEXSSERVICEFN_SEND_RQ,
                           NRN          => NEXSSERVICEFN_SEND_RQ);
  end CM_JOINS;
  
  /*   "   ( )" */
  procedure CM_INS
  (
    NPRN                    in number,  -- 
    NEQOBJKIND              in number,  --  
    NUSERPROCS_DATA         in number,  --  
    NEXSSERVICEFN_UPLOAD    in number,  --      FTP
    NEXSSERVICEFN_SEND_MD   in number,  --      
    NEXSSERVICEFN_SEND_RQ   in number,  --      
    NRN                     out number  --  
  )
  is
  begin
    /*  .  */
    NRN := GEN_ID();
    /*   */    
    insert into UDO_T_EQUIPDSCM
      (RN,
       PRN,
       EQOBJKIND,
       DATA_CONFIG,
       USERPROCS_DATA,
       EXSSERVICEFN_UPLOAD,
       EXSSERVICEFN_SEND_MD,
       EXSSERVICEFN_SEND_RQ)
    values
      (NRN,
       NPRN,
       NEQOBJKIND,
       null,
       NUSERPROCS_DATA,
       NEXSSERVICEFN_UPLOAD,
       NEXSSERVICEFN_SEND_MD,
       NEXSSERVICEFN_SEND_RQ);
  end CM_INS;
  
  /*   "   ( )" */  
  procedure CM_UPD
  (
    NRN                     in number,  --  
    NEQOBJKIND              in number,  --  
    NUSERPROCS_DATA         in number,  --  
    NEXSSERVICEFN_UPLOAD    in number,  --      FTP
    NEXSSERVICEFN_SEND_MD   in number,  --      
    NEXSSERVICEFN_SEND_RQ   in number   --      
  )
  is
  begin
    /*   */
    update UDO_T_EQUIPDSCM T
       set T.EQOBJKIND            = NEQOBJKIND,
           T.USERPROCS_DATA       = NUSERPROCS_DATA,
           T.EXSSERVICEFN_UPLOAD  = NEXSSERVICEFN_UPLOAD,
           T.EXSSERVICEFN_SEND_MD = NEXSSERVICEFN_SEND_MD,
           T.EXSSERVICEFN_SEND_RQ = NEXSSERVICEFN_SEND_RQ
     where T.RN = NRN;
  end CM_UPD;
  
  /*   "   ( )" */
  procedure CM_DEL
  (
    NRN                     in number   --  
  )
  is
  begin
    /*   */
    delete from UDO_T_EQUIPDSCM T where T.RN = NRN;
  end CM_DEL;
  
  /*   "   ( ,  )" */
  procedure CMFL_INS
  (
    NPRN                    in number,   -- 
    SFILE_NAME              in varchar2, --  
    SDESCR                  in varchar2, -- 
    NRN                     out number   --  
  )
  is
  begin
    /*  .  */
    NRN := GEN_ID();
    /*   */
    insert into UDO_T_EQUIPDSCMFL
      (RN, PRN, FILE_NAME, DESCR, QUEUE_ID, STATUS, ERR)
    values
      (NRN, NPRN, SFILE_NAME, SDESCR, null, 0, null);
  end CMFL_INS;
  
  /*   "   ( ,  )" */
  procedure CMFL_DEL
  (
    NRN                     in number   --  
  )
  is
  begin
    /*   */
    delete from UDO_T_EQUIPDSCMFL T where T.RN = NRN;
  end CMFL_DEL;  

  /*     "   ( ,  )" */  
  procedure CMFL_SET_FILE_NAME
  (
    NRN                     in number,  --  
    SFILE_NAME              in varchar2 --  
  )
  is
  begin
    /*    */
    update UDO_T_EQUIPDSCMFL T set T.FILE_NAME = SFILE_NAME where T.RN = NRN;
  end CMFL_SET_FILE_NAME;
  
  /*    "   ( ,  )" */  
  procedure CMFL_SET_STATUS
  (
    NRN                     in number,   --  
    NSTATUS                 in number,   --  (0 - , 1 -   FTP, 2 -    FTP, 3 -    FTP, 4 -    , 5 -     , 6 -       )
    SQUEUE_ID               in varchar2, --   
    SERR                    in varchar2  --   
  )
  is
  begin
    /*       */
    update UDO_T_EQUIPDSCMFL T
       set T.STATUS   = NSTATUS,
           T.QUEUE_ID = SQUEUE_ID,
           T.ERR      = SERR
     where T.RN = NRN;
  end CMFL_SET_STATUS;

  /*   "   ( , )" */
  procedure CMML_INS
  (
    NPRN                    in number,   -- 
    STASK                   in varchar2, --  (TCF -    (Technical Condition Forecast), RUL -    (Remaining Useful Life), FP -   (Failure Predict)) */
    NPRECISION_P            in number,   --  ()
    NRN                     out number   --  
  )
  is
  begin
    /*  .  */
    NRN := GEN_ID();
    /*   */
    insert into UDO_T_EQUIPDSCMML
      (RN, PRN, TASK, PRECISION_P, PRECISION_F, QUEUE_ID, STATUS, ERR)
    values
      (NRN, NPRN, STASK, NPRECISION_P, null, null, 0, null);
  end CMML_INS;
  
  /*   "   ( , )" */
  procedure CMML_UPD
  (
    NRN                     in number,   --  
    STASK                   in varchar2, --  (TCF -    (Technical Condition Forecast), RUL -    (Remaining Useful Life), FP -   (Failure Predict)) */
    NPRECISION_P            in number    --  ()
  )
  is
  begin
    /*   */
    update UDO_T_EQUIPDSCMML T
       set T.TASK        = STASK,
           T.PRECISION_P = NPRECISION_P
     where T.RN = NRN;
  end CMML_UPD;
  
  /*   "   ( , )" */
  procedure CMML_DEL
  (
    NRN                     in number   --  
  )
  is
  begin
    /*   */
    delete from UDO_T_EQUIPDSCMML T where T.RN = NRN;
  end CMML_DEL;  

  /*     "   ( , )" */  
  procedure CMML_SET_PRECISION_F
  (
    NRN                     in number,  --  
    NPRECISION_F            in number   --  ()
  )
  is
  begin
    /*    */
    update UDO_T_EQUIPDSCMML T set T.PRECISION_F = NPRECISION_F where T.RN = NRN;
  end CMML_SET_PRECISION_F;
  
  /*    "   ( , )" */  
  procedure CMML_SET_STATUS
  (
    NRN                     in number,   --  
    NSTATUS                 in number,   --  (0 - , 1 -   , 2 -    , 3 -      )
    SQUEUE_ID               in varchar2, --   
    SERR                    in varchar2  --   
  )
  is
  begin
    /*       */
    update UDO_T_EQUIPDSCMML T
       set T.STATUS   = NSTATUS,
           T.QUEUE_ID = SQUEUE_ID,
           T.ERR      = SERR
     where T.RN = NRN;
  end CMML_SET_STATUS;

end UDO_PKG_EQUIPDS_BASE;
/
