create or replace package UDO_PKG_EQUIPTCF as

  /*     */
  procedure EQCONFIG_HIER
  (
    NPEQCONFIG              in number,  -- .     
    COUT                    out clob    --  XML- 
  );

  /*          */
  procedure EQCONFIG_THOBJ_DG
  (
    NPEQCONFIG              in number   -- .     
  );

end UDO_PKG_EQUIPTCF;
/
create or replace package body UDO_PKG_EQUIPTCF as

  /*      */
  function EQCONFIG_HIER_NODE
  (
    NCUR                    in integer,      --        
    NCOMPANY                in number,       -- .  
    NPEQCONFIG              in number        -- .      
  ) return                  PKG_XMAKE.TNODE  -- XML-  
  is
    XLEAF                   PKG_XMAKE.TNODE; --  
    XCHILD                  PKG_XMAKE.TNODE; --   
    XRES                    PKG_XMAKE.TNODE; --   
  begin
    /*       */
    for C in (select M.RN NRN,
                     M.EQPARENT NHRN,
                     DECODE(M.FICT_REC, 0, M.NAME, DECODE(OL.RN, null, M.NAME, OL.NAME)) SNAME,
                     case
                       when exists
                        (select null
                               from EQCONFIG C
                              where C.EQPARENT = M.RN
                                and exists (select null from V_USERPRIV_HIER_SINGL UP where UP.HIERARCHY = C.RN)) then
                        1
                       else
                        0
                     end NHASCHILDREN
                from EQCONFIG   M,
                     EQOBJLEVEL OL
               where M.PR_OBJ_LEVEL = OL.RN(+)
                 and ((M.FICT_REC = 0) or ((M.FICT_REC = 1) and (CMP_VC2(M.NAME, F_EQCONFIG_EXTRANAME(0)) = 1)))
                 and exists (select null from V_USERPRIV_HIER_SINGL UP where UP.HIERARCHY = M.RN)
                 and COALESCE(M.EQPARENT, 0) = NPEQCONFIG
                 and M.COMPANY = NCOMPANY)
    loop
      /*     */
      if (C.NHASCHILDREN = 1) then
        /*           */
        XCHILD := PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                    SNAME       => 'children',
                                    RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                        RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                            SNAME   => 'id',
                                                                                                            SVALUE  => C.NRN ||
                                                                                                                       '_loader'),
                                                                        RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                            SNAME   => 'label',
                                                                                                            SVALUE  => '...')));
      else
        XCHILD := null;
      end if;
      /*   */
      XLEAF := PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                 SNAME       => 'children',
                                 RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                     RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                         SNAME   => 'id',
                                                                                                         SVALUE  => C.NRN),
                                                                     RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                         SNAME   => 'label',
                                                                                                         SVALUE  => C.SNAME)),
                                 RNODE00     => XCHILD);
      /*     */
      XRES := PKG_XMAKE.CONCAT(ICURSOR => NCUR, RNODE00 => XRES, RNODE01 => XLEAF);
    end loop;
    /*   */
    return XRES;
  end EQCONFIG_HIER_NODE;
  
  /*     */
  procedure EQCONFIG_HIER
  (
    NPEQCONFIG              in number,                             -- .     
    COUT                    out clob                               --  XML- 
  )
  is    
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    NCUR                    integer;                               --    
    XDOC                    PKG_XMAKE.TNODE;                       --   
  begin
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*  XML-     */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR,
                              SNAME   => 'XDATA',
                              RNODE00 => EQCONFIG_HIER_NODE(NCUR => NCUR, NCOMPANY => NCOMPANY, NPEQCONFIG => NPEQCONFIG));
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end EQCONFIG_HIER;

  /*          */
  procedure EQCONFIG_THOBJ_DG
  (
    NPEQCONFIG              in number   -- .     
  )
  is
  begin
    null;
  end EQCONFIG_THOBJ_DG;

end UDO_PKG_EQUIPTCF;
/
