/*
    Парус 8 - Панели мониторинга - ТОиР - Прогнозирование технического состояния
    Панель мониторинга: Корневая панель прогнозирования технического состояния
*/

//---------------------
//Подключение библиотек
//---------------------

import React, { useState, useEffect } from "react"; //Классы React
import { Box, Tabs, Tab } from "@mui/material"; //Интерфейсные компоненты
import { AdminTab } from "./admin_tab"; //Интерфейс администрирования
import { ForecastTab } from "./forecast_tab"; //Интерфейс прогнозирования

//---------
//Константы
//---------

//Режимы работы панели
const MODES = {
    FORECAST: 1,
    ADMIN: 2
};

//-----------
//Тело модуля
//-----------

//Закладка
const TapPanel = ({ children }) => <Box>{children}</Box>;

//Корневая панель прогнозирования технического состояния
const EqsTechCondForecast = () => {
    //Собственное состояние
    const [mode, setMode] = useState(MODES.FORECAST);

    //При переключении закладки
    const handleTabChange = (e, newValue) => setMode(newValue);

    //Генерация содержимого
    return (
        <>
            <Box sx={{ borderBottom: 1, borderColor: "divider" }}>
                <Tabs value={mode} onChange={handleTabChange}>
                    <Tab label="Прогноз" value={MODES.FORECAST} />
                    <Tab label="Обучение" value={MODES.ADMIN} />
                </Tabs>
            </Box>
            {mode == MODES.ADMIN ? (
                <TapPanel>
                    <AdminTab />{" "}
                </TapPanel>
            ) : null}
            {mode == MODES.FORECAST ? (
                <TapPanel>
                    <ForecastTab />
                </TapPanel>
            ) : null}
        </>
    );
};

//----------------
//Интерфейс модуля
//----------------

export { EqsTechCondForecast };
